/*Copyright (C) 2010-2012 Duncan Deveaux

This file is part of Hikou no mizu.

Hikou no mizu is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Hikou no mizu is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Hikou no mizu.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "SoundBufferManager.hpp"

SoundBufferManager::SoundBufferManager()
{
    
}

SoundBufferManager::~SoundBufferManager()
{
    std::map<std::string, SoundBuffer*>::iterator it;
    for (it = m_soundBuffersList.begin(); it != m_soundBuffersList.end(); it++)
        delete it->second;
}

SoundBuffer *SoundBufferManager::getSoundBuffer(const std::string &soundPath)
{
    if (!isSoundBufferLoaded(soundPath))
        loadSoundBuffer(soundPath);
    
    return m_soundBuffersList[soundPath];
}

void SoundBufferManager::loadSoundBuffer(const std::string &soundPath)
{
    SoundBuffer *soundBuffer = new SoundBuffer();
    soundBuffer->loadFromOGG(soundPath);
    
    m_soundBuffersList[soundPath] = soundBuffer;
}

bool SoundBufferManager::isSoundBufferLoaded(const std::string &soundPath)
{
    std::map<std::string, SoundBuffer*>::iterator it;
    it = m_soundBuffersList.find(soundPath);
    
    if (it != m_soundBuffersList.end())
        return true;
    
    return false;
}
